"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JwtOrNativeAuthGuard = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const sdk_nestjs_cache_1 = require("@multiversx/sdk-nestjs-cache");
const sdk_nestjs_common_1 = require("@multiversx/sdk-nestjs-common");
const jwt_authenticate_guard_1 = require("./jwt.authenticate.guard");
const native_auth_guard_1 = require("./native.auth.guard");
let JwtOrNativeAuthGuard = class JwtOrNativeAuthGuard {
    constructor(mxnestConfigService, cacheService) {
        this.mxnestConfigService = mxnestConfigService;
        this.cacheService = cacheService;
    }
    async canActivate(context) {
        const jwtGuard = new jwt_authenticate_guard_1.JwtAuthenticateGuard(this.mxnestConfigService);
        const nativeAuthGuard = new native_auth_guard_1.NativeAuthGuard(this.mxnestConfigService, this.cacheService);
        try {
            const result = await jwtGuard.canActivate(context);
            if (result) {
                return true;
            }
        }
        catch (error) {
        }
        try {
            return await nativeAuthGuard.canActivate(context);
        }
        catch (error) {
            return false;
        }
    }
};
JwtOrNativeAuthGuard = tslib_1.__decorate([
    (0, common_1.Injectable)(),
    tslib_1.__param(0, (0, common_1.Inject)(sdk_nestjs_common_1.MXNEST_CONFIG_SERVICE)),
    tslib_1.__param(1, (0, common_1.Optional)()),
    tslib_1.__metadata("design:paramtypes", [Object, sdk_nestjs_cache_1.CacheService])
], JwtOrNativeAuthGuard);
exports.JwtOrNativeAuthGuard = JwtOrNativeAuthGuard;
//# sourceMappingURL=jwt.or.native.auth.guard.js.map