"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NativeAuthAdminGuard = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const sdk_nestjs_common_1 = require("@multiversx/sdk-nestjs-common");
let NativeAuthAdminGuard = class NativeAuthAdminGuard {
    constructor(mxnestConfigService) {
        this.mxnestConfigService = mxnestConfigService;
    }
    canActivate(context) {
        const admins = this.mxnestConfigService.getSecurityAdmins();
        if (!admins) {
            return false;
        }
        const request = sdk_nestjs_common_1.ExecutionContextUtils.getRequest(context);
        return admins.includes(request.nativeAuth.signerAddress);
    }
};
NativeAuthAdminGuard = tslib_1.__decorate([
    (0, common_1.Injectable)(),
    tslib_1.__param(0, (0, common_1.Inject)(sdk_nestjs_common_1.MXNEST_CONFIG_SERVICE)),
    tslib_1.__metadata("design:paramtypes", [Object])
], NativeAuthAdminGuard);
exports.NativeAuthAdminGuard = NativeAuthAdminGuard;
//# sourceMappingURL=native.auth.admin.guard.js.map